"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
const MessageBusEventEmitter_1 = require("../messageBus/MessageBusEventEmitter");
exports.MessagePublisher = () => {
    return function (target, propertyKey, propertyDescriptor) {
        const originalFunc = propertyDescriptor.value;
        propertyDescriptor.value = async function (...args) {
            const result = await originalFunc.apply(this, args);
            const resultingMessages = Array.isArray(result) && result.every(r => r instanceof __1.Message)
                ? result
                : result instanceof __1.Message
                    ? [result]
                    : null;
            MessageBusEventEmitter_1.MessageEmitter.getMessageEmitter().emit(MessageBusEventEmitter_1.MessageEmitter.PROCESS_SUCCESS, resultingMessages);
            return result;
        };
    };
};
//# sourceMappingURL=MessagePublisher.js.map