"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const uuid = require("uuid");
class Message {
    constructor(descriptor, content, id = null, timestamp = null, parentMessage = null) {
        this.uuid = id ? id : uuid.v4();
        this.descriptor = descriptor;
        this.content = content;
        this.creationDate = timestamp ? new Date(timestamp) : new Date();
        this.parentMessage = parentMessage;
    }
    getUUID() {
        return this.uuid;
    }
    getParentMessage() {
        return this.parentMessage;
    }
    getDescriptor() {
        return this.descriptor;
    }
    getCreationDate() {
        return this.creationDate;
    }
    setParentMessage(parentMessageUUID) {
        this.parentMessage = parentMessageUUID;
    }
}
exports.Message = Message;
//# sourceMappingURL=Message.js.map