"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RabbitMQConnectionFacade_1 = require("../connection/RabbitMQConnectionFacade");
const Mercury_1 = require("../Mercury");
class RabbitMQMessageBus {
    async configure(args) {
        const { brokerHostName, brokerUserName, brokerPassword, appName, serviceName, retryDelay, filterMessages, preFetch } = args;
        this.connectionFacade = new RabbitMQConnectionFacade_1.RabbitMQConnectionFacade(serviceName, appName, retryDelay, filterMessages, preFetch);
        try {
            await this.connectionFacade.connect(brokerHostName, brokerUserName, brokerPassword);
            const messageBindings = Reflect.getMetadata('messageBindings', Mercury_1.Mercury);
            await this.connectionFacade.subscribeAll(messageBindings);
            return true;
        }
        catch (e) {
            throw e;
        }
    }
    async terminate() {
        try {
            await this.connectionFacade.disconnect();
            this.connectionFacade = null;
            return true;
        }
        catch (e) {
            return false;
        }
    }
}
exports.RabbitMQMessageBus = RabbitMQMessageBus;
//# sourceMappingURL=RabbitMQMessageBus.js.map